#!/usr/bin/perl
#
# default parameters
#
##########################
# Make compiler(options) #
##########################
@youbi = ('Mon','Tsu','Wed','Thu','Fri','Sat','Sun');
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$year += 1900;
$mon += 1;
$machine = $^O;
$date = "Date: $year/$mon/$mday($youbi[$wday]) $hour:$min:$sec";

print "Operating system: ",$machine,"\n";
print $date,"\n";

# default commands
$ar="ar";

# cc
if (-f "/opt/FSUNf90/bin/fcc") {
  $cc = "fcc"; $copt = "";
}
elsif (-f "/opt/SUNWspro/bin/cc") {
  $cc = "/opt/SUNWspro/bin/cc"; $copt = "";
}
elsif (-f "/usr/FFC/bin/fcc") {
  $cc = "/usr/FFC/bin/fcc"; $copt = "";
}
elsif (-f "/usr/bin/cc") {
  $cc = "cc"; $copt = "";
}
elsif (-f "/usr/bin/gcc") {
  $cc = "gcc"; $copt = "";
}
elsif (-f "/usr/local/bin/gcc") {
  $cc = "/usr/local/bin/gcc"; $copt = "";
}
else {
  $cc = "cc"; $copt = "";
}

#fc
if (-f "/usr/bin/xlf") {
  $fc = "xlf"; $fopt = ""; $ldflags = "";
}
elsif (-f "/opt/FSUNf90/bin/frt") {
  $fc = "frt"; $fopt = ""; $ldflags = "";
}
elsif (-f "/usr/FFC/bin/frt") {
  $fc = "/usr/FFC/bin/frt"; $fopt = "-rpath /usr/FFC/lib"; 
  $ldflags = "-rpath /usr/FFC/lib";
}
elsif (-f "/opt/fortran/bin/fort77") {
  $fc = "/opt/fortran/bin/fort77"; $fopt = ""; $ldflags = "";
}
elsif (-f "/usr/bin/fort") {
  $fc = "fort"; $fopt = ""; $ldflags = "";
}
elsif (-f "/usr/bin/fort77") {
  $fc = "fort77"; $fopt = ""; $ldflags = "";
}
elsif (-f "/usr/local/bin/fort") {
  $fc = "fort"; $fopt = ""; $ldflags = "";
}
elsif (-f "/usr/bin/f77") {
  $fc = "f77"; $fopt = ""; $ldflags = "";
}
elsif (-f "/usr/bin/g77") {
  $fc = "g77"; $fopt = ""; $ldflags = "";
}
elsif (-f "/usr/local/bin/g77") {
  $fc = "g77"; $fopt = ""; $ldflags = "";
}
else {
  $fc = "g77"; $fopt = ""; $ldflags = "";
}

# machine dependent functions
$mdfuncs="";

# machine dependent part
if ($machine=~/FreeBSD/i) {
  $copt = "-O -Wuninitialized -Wall"; $fopt = "-O -Wuninitialized -Wall";
}
elsif ($machine=~/Linux-alpha/i) {
  $copt = ""; $fopt = "";
}
elsif ($machine=~/Linux/i) {
  $copt = ""; $fopt = "";
}
elsif ($machine=~/AIX/i) {
#  $copt = "";
#  $fopt = "-O3 -qstrict -qarch=pwr3 -qtune=pwr3 -qextname";
#  $fopt = "-qsuppress=1501-245 -qsuppress=1501-510 -qstrict -qextname";
#  $fopt = "-qextname -qautodbl=dbl8";
  $fopt = "-qextname";
#  $copt = "-qlanglvl=ansi -qsuppress=1501-245 -qinfo=gen";
  $copt = "-qlanglvl=ansi";
}
elsif ($machine=~/SunOS/i) {
  $mdfuncs = "bstime_sun.f"; $copt = ""; $fopt = "";
}
elsif ($machine=~/HP-UX/i) {
  $copt = "-Ae"; $fopt = "+ppu";
}
elsif ($machine=~/OFS1/i) {
  $copt = ""; $fopt = "";
}
elsif ($machine=~/hiux/i) {
  $mdfuncs = "bsdate_hiux.f bstime_hiux.f"; $copt = ""; $fopt = "";
}

################
# Find process #
################
$nsub = 0;
open(IN,"proc.list") || die "cannot open proc.list for reading";
while(<IN>) {
  if (/^\[/) {
    @wds1 = split(/\:+/,$_); 
    @wds2 = split(/\[+/,$wds1[0]);
    @wds3 = split(/\]+/,$wds2[1]);
    if (-d "bbbb/$wds3[0]" || -d "diboson/$wds3[0]" || -d "qcd/$wds3[0]"
	|| -d "top/$wds3[0]" || -d "wjets/$wds3[0]" || -d "zjets/$wds3[0]") {
      if (-d "bbbb/$wds3[0]")    { $subproc[$nsub] = "bbbb/$wds3[0]";    }
      if (-d "diboson/$wds3[0]") { $subproc[$nsub] = "diboson/$wds3[0]"; }
      if (-d "qcd/$wds3[0]")     { $subproc[$nsub] = "qcd/$wds3[0]";     }
      if (-d "top/$wds3[0]")     { $subproc[$nsub] = "top/$wds3[0]";     }
      if (-d "wjets/$wds3[0]")   { $subproc[$nsub] = "wjets/$wds3[0]";   }
      if (-d "zjets/$wds3[0]")   { $subproc[$nsub] = "zjets/$wds3[0]";   }
      $subprocid[$nsub] = $wds3[0];
      print "process: [", $subprocid[$nsub],"] was detected in ",
	$subproc[$nsub]," ...\n";
      $nsub++;
    }
  }
}
close(IN);

#################
# Make Makefile #
#################
$ftname = "Makefile";
open(OUT,">$ftname");

print OUT <<COMPILER;
# Make file for GR\@PPA
#     (c)copyright 1990-1999 Minami-Tateya Group, Japan
#-----------------------------------------------------------------------
# Generated on $date
#-----------------------------------------------------------------------
# 1. make kinem
# 2. make all or [subprocess]
# 3. make install-[subprocess]
# 4. make example
#
GRAPPADIR = \$(PWD)
GRAPPAINCDIR = \$(GRAPPADIR)/inc/
GRAPPALIBDIR = \$(GRAPPADIR)/lib/
#-----------------------------------------------------------------------
# Set PYTHIA library
PYTH_LIB  = /home/tsuno/lib/libpythia6226.a
#-----------------------------------------------------------------------
# Set HERWIG library
HERW_LIB  = /home/tsuno/lib/libherwig6506.a
HERW_INC  = /home/tsuno/lib/

#-----------------------------------------------------------------------
# LHAPDF library
LHAPDF_LIB  = 

#-----------------------------------------------------------------------
# Set cern library
CERN_LIB  = 

# Set Compiler
MACHINE   = $machine
FC        = $fc
FFLAGS    = $fopt
CC        = $cc
COPT      = $copt
LDFLAGS   = $ldflags
AR        = $ar
MDFUNCS   = $mdfuncs

# Amplitude
#-----------------------------------------------------------------------
all\: baseslib chanellib grcgenlib \\
COMPILER

for ($i = 0; $i < $nsub-1; $i++) {
  print OUT "     ",$subprocid[$i],"  \\\n";
}
print OUT "     ",$subprocid[$nsub-1],"\n\n";
print OUT "kinem: grcgenlib\n\n";
print OUT "integ: baseslib chanellib\n\n";

print OUT <<ABASES;
baseslib:basesv5.1/Makefile
	(cd basesv5.1; make FC="\${FC}" FFLAGS="\${FFLAGS}")

basesv5.1/Makefile: Makefile basesv5.1/Makefile.templ
	echo "LIBDIR    = \$(GRAPPALIBDIR)" > basesv5.1/Makefile
	cat basesv5.1/Makefile.templ >> basesv5.1/Makefile

chanellib:chanel/Makefile
	(cd chanel; make FC="\${FC}" FFLAGS="\${FFLAGS}")

chanel/Makefile: Makefile chanel/Makefile.templ
	echo "LIBDIR    = \$(GRAPPALIBDIR)" > chanel/Makefile
	cat chanel/Makefile.templ >> chanel/Makefile

grcgenlib:grckinem/Makefile
	(cd grckinem; cp ./../inc/define.h ./; cp ./../inc/define2.h ./; \\
         make FC="\${FC}" FFLAGS="\${FFLAGS}"; rm -f define.h define2.h;)

grckinem/Makefile: Makefile grckinem/Makefile.templ
	echo "LIBDIR    = \$(GRAPPALIBDIR)" > grckinem/Makefile
	echo "GRAPPAINCDIR = \$(GRAPPAINCDIR)" >> grckinem/Makefile
	cat grckinem/Makefile.templ >> grckinem/Makefile
#-----------------------------------------------------------------------
ABASES

for ($i = 0; $i < $nsub; $i++) {
  print OUT <<AMPLITUDE;
$subprocid[$i]:$subproc[$i]/Makefile
	(cd $subproc[$i]; cp ./../../inc/define.h ./; \\
         make FC="\${FC}" FFLAGS="\${FFLAGS}"; rm define.h;)
$subproc[$i]/Makefile: Makefile $subproc[$i]/Makefile.templ
	echo "#define $subprocid[$i]" >> ./inc/define2.h
	echo "LIBDIR    = \$(GRAPPALIBDIR)" > $subproc[$i]/Makefile
	echo "GRAPPAINCDIR = \$(GRAPPAINCDIR)" >> $subproc[$i]/Makefile
	cat $subproc[$i]/Makefile.templ >> $subproc[$i]/Makefile
#-----------------------------------------------------------------------

AMPLITUDE
}

print OUT "install:\n";
print OUT "\t(cd basesv5.1; make install)\n";
print OUT "\t(cd chanel; make install)\n";
print OUT "\t(cd grckinem; make install)\n";
for ($i = 0; $i < $nsub; $i++) {
  print OUT "\t(cd $subproc[$i]; make install)\n";
}

print OUT "\n";
print OUT "install-kinem:\n";
print OUT "\t(cd grckinem; make install)\n";

print OUT "\n";
print OUT "install-integ:\n";
print OUT "\t(cd basesv5.1; make install)\n";
print OUT "\t(cd chanel; make install)\n";

for ($i = 0; $i < $nsub; $i++) {
  print OUT "\n";
  print OUT "install-$subprocid[$i]:\n";
  print OUT "\t(cd $subproc[$i]; make install)\n";
}

print OUT <<EXAMPLE;

#-----------------------------------------------------------------------
example:example/pythia/Makefile example/herwig/Makefile example/alone/Makefile

example/pythia/Makefile:Makefile example/pythia/Makefile.templ
	echo "GRAPPADIR    = \$(GRAPPADIR)" > example/pythia/Makefile
	echo "GRAPPALIBDIR = \$(GRAPPALIBDIR)" >> example/pythia/Makefile
	echo "GRAPPAINCDIR = \$(GRAPPAINCDIR)" >> example/pythia/Makefile
	echo "PYTH_LIB = \$(PYTH_LIB)" >> example/pythia/Makefile
	echo "CERN_LIB = \$(CERN_LIB)" >> example/pythia/Makefile
	echo "LHAPDF_LIB = \$(LHAPDF_LIB)" >> example/pythia/Makefile
	echo "FC = \$(FC)" >> example/pythia/Makefile
	echo "FFLAGS = \$(FFLAGS)" >> example/pythia/Makefile
	cat example/pythia/Makefile.templ >> example/pythia/Makefile

example/herwig/Makefile:Makefile example/herwig/Makefile.templ
	echo "GRAPPADIR    = \$(GRAPPADIR)" > example/herwig/Makefile
	echo "GRAPPALIBDIR = \$(GRAPPALIBDIR)" >> example/herwig/Makefile
	echo "GRAPPAINCDIR = \$(GRAPPAINCDIR)" >> example/herwig/Makefile
	echo "HERW_LIB = \$(HERW_LIB)" >> example/herwig/Makefile
	echo "HERW_INC = \$(HERW_INC)" >> example/herwig/Makefile
	echo "CERN_LIB = \$(CERN_LIB)" >> example/herwig/Makefile
	echo "LHAPDF_LIB = \$(LHAPDF_LIB)" >> example/herwig/Makefile
	echo "FC = \$(FC)" >> example/herwig/Makefile
	echo "FFLAGS = \$(FFLAGS)" >> example/herwig/Makefile
	cat example/herwig/Makefile.templ >> example/herwig/Makefile

example/alone/Makefile:Makefile example/alone/Makefile.templ
	echo "GRAPPADIR    = \$(GRAPPADIR)" > example/alone/Makefile
	echo "GRAPPALIBDIR = \$(GRAPPALIBDIR)" >> example/alone/Makefile
	echo "GRAPPAINCDIR = \$(GRAPPAINCDIR)" >> example/alone/Makefile
	echo "CERN_LIB = \$(CERN_LIB)" >> example/alone/Makefile
	echo "LHAPDF_LIB = \$(LHAPDF_LIB)" >> example/alone/Makefile
	echo "FC = \$(FC)" >> example/alone/Makefile
	echo "FFLAGS = \$(FFLAGS)" >> example/alone/Makefile
	cat example/alone/Makefile.templ >> example/alone/Makefile
#-----------------------------------------------------------------------

EXAMPLE

print OUT "clean-all:\n";
print OUT "\t(cd basesv5.1; make clean)\n";
print OUT "\t(cd chanel; make clean)\n";
print OUT "\t(cd grckinem; make clean)\n";
for ($i = 0; $i < $nsub; $i++) {
  print OUT "\t(cd $subproc[$i]; make clean)\n";
}
print OUT "\t(cd example/pythia; make clean)\n";
print OUT "\t(cd example/herwig; make clean)\n";
print OUT "\t(cd example/alone; make clean)\n";
print OUT "\t(rm -f ./inc/define2.h)\n";

print OUT "\n";
print OUT "clean-kinem:\n";
print OUT "\t(cd grckinem; make clean)\n";

print OUT "\n";
print OUT "clean-integ:\n";
print OUT "\t(cd basesv5.1; make clean)\n";
print OUT "\t(cd chanel; make clean)\n";

for ($i = 0; $i < $nsub; $i++) {
  print OUT "\n";
  print OUT "clean-$subprocid[$i]:\n";
  print OUT "\t(cd $subproc[$i]; make clean)\n";
}

print OUT "\n";
print OUT "clean-example:\n";
print OUT "\t(cd example/pythia; make clean)\n";
print OUT "\t(cd example/herwig; make clean)\n";
print OUT "\t(cd example/alone; make clean)\n";

print OUT "\n";
print OUT "install-clean:\n";
print OUT "\trm -f \${GRAPPALIBDIR}/*.a\n";
print OUT "\trm -f basesv5.1/Makefile\n";
print OUT "\trm -f chanel/Makefile\n";
print OUT "\trm -f grckinem/Makefile\n";
for ($i = 0; $i < $nsub; $i++) {
  print OUT "\trm -f $subproc[$i]/Makefile\n";
}
print OUT "\trm -f example/pythia/Makefile\n";
print OUT "\trm -f example/herwig/Makefile\n";
print OUT "\trm -f example/alone/Makefile\n";

close(OUT);

print "\n";
print "Read process list...\n";
for ($i = 0; $i < $nsub; $i++) { $ichk[$i] = 0; $iscnt[$i] = 0; }
$stat = 0;
open(IN,"proc.list") || die "cannot open proc.list for reading";
while(<IN>) {
  if (/Date/) {
    print "Version : $_ was detected...\n"
  }
  else {
    if (/^\[/) { $stat = 0; $icnt = 0; $ip = -1;}
    if ($stat == 0) {
      for ($i = 0; $i < $nsub; $i++) {
	if (/\[$subprocid[$i]\]/) {
	  $stat = 1; $ichk[$i] = 1; $ip = $i;
	  @wds1 = split(/\:+/,$_);       @wds2 = split(/\s+/,$wds1[1]);
	  @wds3 = split(/\[+/,$wds2[0]); @wds4 = split(/\]+/,$wds3[1]);
	  $maincode[$i] = $wds4[0];
	  print $_;
	}
      }
    }
    elsif ($stat == 1) {
      @swds1 = split(/\[+/,$_);
      if (length($swds1[1]) > 0) {
	@swds2 = split(/\]+/,$swds1[1]);
	$subcode[$ip][$icnt++] = $swds2[0];
	$iscnt[$ip] = $icnt;
	print $_;
      }
    }
  }
}
close(IN);

for ($i = 0; $i < $nsub; $i++) {
  if ($ichk[$i] == 0) {
    print "Error: no [",$subprocid[$i],"] in the table.\n";
    print "The [",$subprocid[$i],"] is not linked in the kinematics library.\n";
    print "Update the latest proc.list .\n";
  }
  else {
    print $maincode[$i]," -> ";
    for ($j = 0; $j < $iscnt[$i]; $j++) {
      print $subcode[$i][$j]," ";
    }
    print "\n";
  }
}

##################
# Make grckorg.F #
##################
open(IN,"./grckinem/grckorg.F.tpl") || die "cannot open grckorg.F for reading";
open(OUT,">kinit.tmp") || die "cannot creat $recfile";
while(<IN>) {
  if (/Add/ && /FUNC/) {
    for ($i = 0; $i < $nsub; $i++) {
      if ($ichk[$i] == 1) {
	print OUT "C+---------------------------------------------------------+\n";
	print OUT "#ifdef $subprocid[$i]\n";
	print OUT "      if (igsub.eq.$maincode[$i]) then\n";
	print OUT "         call pl$subprocid[$i](1,0)\n";
	print OUT "      endif\n";
	for ($j = 0; $j <  $iscnt[$i]; $j++) {
	  print OUT "      if (jproc.eq.$subcode[$i][$j]) then\n";
	  print OUT "         if (igsub.eq.$maincode[$i]) jproc = $maincode[$i]\n";
	  print OUT "         func = fnc$subcode[$i][$j](x)\n";
	  print OUT "      endif\n";
	}
	print OUT "#endif\n";
      }
    }
    print OUT "C+---------------------------------------------------------+\n";
    print OUT $_;
  }
  elsif (/Add/ && /SPDETC/) {
    for ($i = 0; $i < $nsub; $i++) {
      if ($ichk[$i] == 1) {
	print OUT "C+---------------------------------------------------------+\n";
	print OUT "#ifdef $subprocid[$i]\n";
	for ($j = 0; $j <  $iscnt[$i]; $j++) {
	  print OUT "      if (igsub.eq.$subcode[$i][$j]) then\n";
	  print OUT "         call grc$subcode[$i][$j]detc(isel)\n";
	  print OUT "      endif\n";
	}
	print OUT "#endif\n";
      }
    }
    print OUT "C+---------------------------------------------------------+\n";
    print OUT $_;
  }
  elsif (/Add/ && /SPDETH/) {
    for ($i = 0; $i < $nsub; $i++) {
      if ($ichk[$i] == 1) {
	print OUT "C+---------------------------------------------------------+\n";
	print OUT "#ifdef $subprocid[$i]\n";
	for ($j = 0; $j <  $iscnt[$i]; $j++) {
	  print OUT "      if (igsub.eq.$subcode[$i][$j]) then\n";
	  print OUT "         call grc$subcode[$i][$j]deth(isel)\n";
	  print OUT "      endif\n";
	}
	print OUT "#endif\n";
      }
    }
    print OUT "C+---------------------------------------------------------+\n";
    print OUT $_;
  }
  elsif (/Add/ && /PROC/) {
    for ($i = 0; $i < $nsub; $i++) {
      if ($ichk[$i] == 1) {
	print OUT "C+---------------------------------------------------------+\n";
	print OUT "#ifdef $subprocid[$i]\n";
	print OUT "      if (igsub.eq.$maincode[$i]) then\n";
	print OUT "         call pl$subprocid[$i](2,isub)\n";
	print OUT "      endif\n";
	for ($j = 0; $j <  $iscnt[$i]; $j++) {
	  print OUT "      if (igsub.eq.$subcode[$i][$j]) then\n";
	  print OUT "         call pl$subprocid[$i](2,isub)\n";
	  print OUT "      endif\n";
	}
	print OUT "#endif\n";
      }
    }
    print OUT "C+---------------------------------------------------------+\n";
    print OUT $_;
  }
  elsif (/Add/ && /KINEM/) {
    for ($i = 0; $i < $nsub; $i++) {
      if ($ichk[$i] == 1) {
	print OUT "C+---------------------------------------------------------+\n";
	print OUT "#ifdef $subprocid[$i]\n";
	print OUT "      if (igsub.eq.$maincode[$i]) then\n";
	print OUT "         call pl$subprocid[$i](3,0)\n";
	print OUT "      endif\n";
	for ($j = 0; $j <  $iscnt[$i]; $j++) {
	  print OUT "      if (igsub.eq.$subcode[$i][$j]) then\n";
	  print OUT "         call pl$subprocid[$i](3,0)\n";
	  print OUT "      endif\n";
	}
	print OUT "#endif\n";
      }
    }
    print OUT "C+---------------------------------------------------------+\n";
    print OUT $_;
  }
  elsif (/Add/ && /XSET/) {
    for ($i = 0; $i < $nsub; $i++) {
      if ($ichk[$i] == 1) {
	print OUT "C+---------------------------------------------------------+\n";
	print OUT "#ifdef $subprocid[$i]\n";
	print OUT "      if (igsub.eq.$maincode[$i]) then\n";
	print OUT "         call pl$subprocid[$i](4,isel)\n";
	print OUT "      endif\n";
	for ($j = 0; $j <  $iscnt[$i]; $j++) {
	  print OUT "      if (igsub.eq.$subcode[$i][$j]) then\n";
	  print OUT "         call pl$subprocid[$i](4,isel)\n";
	  print OUT "      endif\n";
	}
	print OUT "#endif\n";
      }
    }
    print OUT "C+---------------------------------------------------------+\n";
    print OUT $_;
  }
  else {
    print OUT $_;
  }
}
close(IN);
close(OUT);
system("mv kinit.tmp ./grckinem/grckorg.F");

#################
# Make grcpar.F #
#################
open(IN,"./grckinem/grcpar.F.tpl") || die "cannot open grcpar.F.tpl for reading";
open(OUT,">grcpar.tmp") || die "cannot creat grcpar.tmp";
while(<IN>) {
  print OUT $_;
  if (/^C\+=================/) {
    for ($i = 0; $i < $nsub; $i++) {
      open(IN2,"./$subproc[$i]/param.tpl") || die "cannot open ./$subproc[$i]/param.tpl for reading";
      while(<IN2>) {
	print OUT $_;
      }
      close(IN2);
      print OUT "C+================================================\n";
    }
  }
}
close(IN);
close(OUT);
system("cp grcpar.tmp ./example/pythia/grcpar.F");
system("cp grcpar.tmp ./example/herwig/grcpar.F");
system("cp grcpar.tmp ./example/alone/grcpar.F");
system("rm grcpar.tmp");

###############################
# Make example/Makefile.templ #
###############################
@egen = ('alone','pythia','herwig');
for ($j = 0; $j < 3; $j++) {
  open(IN,"./example/$egen[$j]/Makefile.templ") || die "cannot open Makefile.templ for reading";
  open(OUT,">eMakefile.tmp") || die "cannot creat eMakefile.tmp";
  while(<IN>) {
    if (/\[your\ process\]/) {
      print OUT "GRAPPALIB  = -lgrcpygen ";
      for ($i = 0; $i < $nsub; $i++) {
	print OUT "-l$subprocid[$i] ";
      }
      print OUT "-lbases -lchanel\n";
    }
    else {
      print OUT $_;
    }
  }
  close(IN);
  close(OUT);
  system("mv eMakefile.tmp ./example/$egen[$j]/Makefile.templ");
}

print "done... \n";
print "Next: type make [subprocess dir]/all .\n";

