      PROGRAM ALSAMPLE
C Example to run the stand-alone mode of GR@PPA.
C We welcome comments and bug reports.
C S. Tsuno, tsuno@fnal.gov

C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

C...Include GR@PPA common parameter.
      INCLUDE 'grchad.inc'

      EXTERNAL DRN
      INTEGER IEV,IDUMMY,IGSEC
      DOUBLE PRECISION SUMXSEC,CRAN

C...Statement to link the block data; comment out if any trouble.
C      EXTERNAL GRCBLOCKD

C...Initialization.
      CALL UPINIT

      SUMXSEC = 0.0D0
      DO I = 1,NPRUP
         SUMXSEC = XSECUP(i) + SUMXSEC
      ENDDO

C...Event loop.
      WRITE(*,'(/10X,''########## Start generating events ##########''
     >     )')

      DO IEV = 1,100

C...Event generation.
         CRAN = DRN(IDUMMY)*SUMXSEC
         IGSEC = 0
         DO WHILE (CRAN.GT.0.0D0)
            IGSEC = IGSEC + 1
            CRAN = CRAN - XSECUP(IGSEC)
         ENDDO
         IDPRUP = LPRUP(IGSEC)

         CALL UPEVNT

C...Data Store.

         IF (IEV.LE.5 .OR. MOD(IEV,1000).EQ.0) THEN
            WRITE(*,*) ' '
            WRITE(*,*) 'Event# ',IEV
            WRITE(*,100)
            WRITE(*,101)
            WRITE(*,102) NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP
            WRITE(*,100)
            WRITE(*,103)
            DO I=1,NUP
               WRITE(*,104) I,IDUP(I),ISTUP(I),(MOTHUP(J,I),J=1,2),
     >              (ICOLUP(J,I),J=1,2),(PUP(J,I),J=1,5),
     >              VTIMUP(I),SPINUP(I)  
            ENDDO
            WRITE(*,100)
         ENDIF

      ENDDO

      WRITE(*,'(/8X,''########## Event generation completed ##########''
     >     /)')

 100  FORMAT(' -----------------------------------------------------',
     >     '--------------------------------------------------------',
     >     '-----')
 101  FORMAT(5X,' NUP IDPRUP    XWGTUP    SCALUP    AQEDUP    AQCDUP')
 102  FORMAT(5X,I4,I7,4E10.3)
 103  FORMAT('     IDUP ISTUP MOTHUP1 MOTHUP2 ICOLUP1 ICOLUP2',
     >     '      PUP1      PUP2      PUP3      PUP4      PUP5',
     >     '    VTIMUP  SPINUP')
 104  FORMAT(I4,I5,I6,4I8,5F10.3,E10.3,F8.3)

      END


