      PROGRAM PYSAMPLE
C Example how to interface user-defined processes to PYTHIA based on 
C the Les Houches common-block agreement. See the PYTHIA 6.2 manual for 
C the details. We welcome comments and bug reports.
C S. Tsuno, tsuno@fnal.gov

C...Double precision and integer declarations.
      IMPLICIT DOUBLE PRECISION(A-H, O-Z)
      INTEGER PYK,PYCHGE,PYCOMP
C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA

C...Standard PYTHIA commonblocks.
      INTEGER N,NPAD,K
      REAL*8 P,V
      COMMON/PYJETS/N,NPAD,K(4000,5),P(4000,5),V(4000,5)
      INTEGER MSTU,MSTJ
      REAL*8 PARU,PARJ
      COMMON/PYDAT1/MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      INTEGER MDCY,MDME,KFDP
      REAL*8 BRAT
      COMMON/PYDAT3/MDCY(500,3),MDME(8000,2),BRAT(8000),KFDP(8000,5)
      INTEGER MSEL,MSELPD,MSUB,KFIN
      REAL*8 CKIN
      COMMON/PYSUBS/MSEL,MSELPD,MSUB(500),KFIN(2,-40:40),CKIN(200)
      INTEGER MSTP,MSTI
      REAL*8 PARP,PARI
      COMMON/PYPARS/MSTP(200),PARP(200),MSTI(200),PARI(200)

C...User process event common block.
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500) 
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP  
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,IDUP(MAXNUP),
     &ISTUP(MAXNUP),MOTHUP(2,MAXNUP),ICOLUP(2,MAXNUP),PUP(5,MAXNUP),
     &VTIMUP(MAXNUP),SPINUP(MAXNUP)  
      SAVE /HEPEUP/ 

C...Local stuff.
      INTEGER IEV,NEV,IORD_ALS,NFRV_ALS
      REAL*8 ALAM_ALS

C...Statement to link the block data; comment out if any trouble.
C      EXTERNAL GRCBLOCKD

C...Number of events. 
      NEV = 100                 ! Number of events

C...If you chose to use the built-in PDF in PYTHIA, 
C...you need to declare which PDF you use here.

C...PDF and Coupling.
C...If PYTHIA-PDF is used, comment them out.
CCC      MSTP(51)  = 7             ! CTEC5L
CCC      MSTP(58)  = 5             ! Nr. of flavor in PDF
CCC      MSTU(101) = 1             ! running alpha_em
CCC      IORD_ALS  = 1             ! first-order running alpha_s
CCC      NFRV_ALS  = 5             ! Nr. of flavors assumed in alpha_s
CCC      ALAM_ALS  = 0.146d0       ! Lambda used in alpha_s
CCC
CCC      MSTU(111) = IORD_ALS
CCC      MSTU(112) = NFRV_ALS
CCC      PARU(112) = ALAM_ALS


C...Pythia initialization.
C   Switch off unnecessary aspects of Pythia.
C      MSTP(61)  = 0             ! Initial state radiation OFF
C      MSTP(71)  = 0             ! Final state radiation OFF
C      MSTP(81)  = 0             ! Multiple interaction OFF
C      MSTP(111) = 0             ! Hadronization OFF

C...Initialization.
      CALL PYINIT('USER',' ',' ',0,0d0)

C...If PYTHIA-PDF is used, comment them out.
C...Set them again to make sure they are really used the same parameters.
CCC      MSTU(111) = IORD_ALS
CCC      MSTU(112) = NFRV_ALS
CCC      PARU(112) = ALAM_ALS

C...Event loop.
      DO IEV = 1,NEV

         CALL PYEVNT

         if (mod(iev,5).eq.0) then
            CALL PYLIST(7)
         endif

C...Data Store.

         IF (MOD(IEV,1000).EQ.0) THEN
            WRITE(*,*) IEV
         ENDIF
         
C...End of loop over events.
      ENDDO

C...Cross section table.
      CALL PYSTAT(1)

      END
