      SUBROUTINE UPINIT
      IMPLICIT NONE
      INCLUDE 'grchad.inc'

C...User process initialization commonblock.
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      SAVE /HEPRUP/

      INTEGER I,J
      CHARACTER*3 CBEAM
      CHARACTER*60 MCDBNAME
      DOUBLE PRECISION SIGMAX

C...PDF common parameter.
      CHARACTER*20      PARM(20)
      DOUBLE PRECISION  VALUE(20)

C...Initialization of GR@PPA parameters.
      CALL GRCINIT

C...Beams: 'PP' for proton-proton, and 'PAP' for proton-antiproton.
      CBEAM = 'PP'              ! LHC
C      CBEAM = 'PAP'             ! Tevatron

C...CM energy in GeV. 
      GRCECM = 14000.0D0         ! LHC
C      GRCECM =  1960.0D0         ! Tevatron

C...Kinematical cuts for "jets".
      GPTCUT   = 20.0D0         ! Pt Cut
      GETACUT  = 3.0D0          ! Eta Cut
      GRCONCUT = 0.4D0          ! RCone Cut

C   Similar cuts can be applied to each final-state particle
C   using the parameters GRCPTCUT(i), GRCETACUT(i) and GRCRCONCUT(i).
C   Furthermore, users can define their own cuts by editing the 
C   subroutine GRCUSRCUT in grcpar.F.
C
C   Users have to apply certain cuts on the separation between  
C   Z/gamma* decay products in Z/gamma* production processes.
C   For example, for the process 110, 111 and 112, activate the
C   following cuts, or define other cuts in GRCUSRCUT.
C      GRCPTCUT(1)   = 20.D0
C      GRCETACUT(1)  = 3.0D0
C      GRCRCONCUT(1) = 0.4D0
C      GRCPTCUT(2)   = 20.D0
C      GRCETACUT(2)  = 3.0D0
C      GRCRCONCUT(2) = 0.4D0

C...Set Jet flavor.
      IGJFLV(1) = 1             ! d-jet
      IGJFLV(2) = 1             ! u-jet
      IGJFLV(3) = 1             ! s-jet
      IGJFLV(4) = 1             ! c-jet
      IGJFLV(5) = 1             ! b-jet
      IGJFLV(7) = 1             ! gluon-jet

C...Set W/Z Decay Mode. (1/0:on/off)
      IGWMOD(1)  = 0            ! W -> d~ u
      IGWMOD(2)  = 0            ! W -> d~ c
      IGWMOD(5)  = 0            ! W -> s~ u
      IGWMOD(6)  = 0            ! W -> s~ c
      IGWMOD(9)  = 0            ! W -> b~ u
      IGWMOD(10) = 0            ! W -> b~ c
      IGWMOD(17) = 1            ! W -> e nu_e
      IGWMOD(18) = 0            ! W -> mu nu_mu
      IGWMOD(19) = 0            ! W -> tau nu_tau

      IGZMOD(1)  = 0            ! z -> d d~
      IGZMOD(2)  = 0            ! z -> u u~
      IGZMOD(3)  = 0            ! z -> s s~
      IGZMOD(4)  = 0            ! z -> c c~
      IGZMOD(5)  = 0            ! z -> b b~
      IGZMOD(6)  = 0            ! z -> t t~
      IGZMOD(9)  = 1            ! z -> e e
      IGZMOD(10) = 0            ! z -> nu_e nu_e
      IGZMOD(11) = 0            ! z -> mu mu
      IGZMOD(12) = 0            ! z -> nu_mu nu_mu
      IGZMOD(13) = 0            ! z -> tau tau
      IGZMOD(14) = 0            ! z -> nu_tau nu_tau

C...Set seeds for random numbers.
      IRSEED = 12345

C...Number of external processes, and process numbers. 
      NPRUP = 1
      LPRUP(1) = 101            ! W + 1 jet

C...Set PDF.
      PDFGUP(1) = -1
      PDFSUP(1) = -1
      PDFGUP(2) = PDFGUP(1)
      PDFSUP(2) = PDFSUP(1)

C...If CERNLIB-PDF is used, comment them out.
CCCC...Initialization of PDFLIB.
CCC      PARM(1) = 'Init0'
CCC      VALUE(1) = 0.0d0
CCC      CALL PDFSET(PARM, VALUE)
CCC
CCCC...Set PDF's of incoming beams: CTEQ 5L.
CCC      PARM(1) = 'Nptype'
CCC      VALUE(1) = 1
CCC      PARM(2) = 'Ngroup'
CCC      VALUE(2) = 4
CCC      PARM(3) = 'Nset'
CCC      VALUE(3) = 46
CCCC      PARM(4) = 'LO'
CCCC      VALUE(4) = 1
CCCC      PARM(5) = 'NFL'
CCCC      VALUE(5) = 5
CCCC      PARM(6) = 'QCDL5'
CCCC      VALUE(6) = 0.181d0
CCC      CALL PDFSET(PARM, VALUE)
CCC
CCC      PDFGUP(1) = VALUE(2)
CCC      PDFSUP(1) = VALUE(3)
CCC      PDFGUP(2) = PDFGUP(1)
CCC      PDFSUP(2) = PDFSUP(1)

C...If LHA-PDF is used, comment them out.
CCCC...Initialization of LHAPDF
CCCC   The target PDF-set file has to be copied to this directory, or 
CCCC   edit the next line properly.
CCC      CALL InitPDFset('cteq6.LHpdf')
CCC      CALL InitPDF(0)

C...If CTEQ6-PDF is used, comment them out.
      CALL SetCtq6(4)

C...Set incoming beams in the interface common.
      IF (CBEAM.EQ.'PP') THEN
         IDBMUP(1) = 2212
         IDBMUP(2) = 2212
      ELSEIF (CBEAM.EQ.'PAP') THEN
         IDBMUP(1) = 2212
         IDBMUP(2) = -2212
      ELSE
         PRINT '('' Incorrect beam definition: CBEAM = '',A4)',
     >        CBEAM
         STOP
      ENDIF
      EBMUP(1) = GRCECM/2.0D0
      EBMUP(2) = GRCECM/2.0D0

C...Decide on weighting strategy: unweighted on input.
      IDWTUP = 2

C...Check process.
      DO I = 1,NPRUP
         IF (LPRUP(I).LT.100.OR.LPRUP(I).GT.600) THEN
            WRITE(*,*) 'GRC::Error: Wrong process ID',LPRUP(I),'.'
            STOP
         ENDIF
      ENDDO

C...Only call GR@PPA.
      DO I = 1,NPRUP
         CALL GRCPYGEN(CBEAM,LPRUP(I),1,SIGMAX)
         XSECUP(i) = SIGMAX
         XMAXUP(i) = 1.0D0
      ENDDO

C...If neccessary, write the unweighted events in the file.
C...Also needed to remove this comment-out in upevnt.F.
C      MCDBNAME = 'test.gen'
C      CALL GRCMCDBSRT(MCDBNAME)

C...Done.
      RETURN
      END
